// C++ Vererbung: Geom. Objekte
// Abstrakte Klasse Bigobj, Implementierung
//
// Klaus Kusche, 2011

#include "bigobj.hxx"

#include <cstdlib>
#include <iostream>

using namespace std;

BigObj* BigObj::MzBuf[MzBufSize];
int BigObj::MzBufCnt = 0;

void BigObj::setPos(int x, int y) {
  undraw();
  mX = x;
  mY = y;
  draw();
}
  
void BigObj::setSize(int w, int h) {
  undraw();
  mW = w;
  mH = h;
  draw();
}

void BigObj::setZ(int z) {
  int i;
  
  if (mZ == z) return;  /* keine nderung des z-Wertes: Nichts zu tun! */

  /* wenn das Objekt schon einen z-Wert hatte: */
  if (mZ > 0) {
    /* "this" in MzBuf suchen (sollte enthalten sein!) .... */
    for (i = 0; ; ++i) {
      if (i == MzBufCnt) {
        cerr << "Internal error: Element missing from zBuf" << endl;
        exit(1);
      }
      if (MzBuf[i] == this) break;
    }
    /* ... und rauslschen:
     * MzList wird eins krzer, alle Elemente hinter i rutschen eins vor */
    --MzBufCnt;
    for ( ; i < MzBufCnt; ++i) {
      MzBuf[i] = MzBuf[i + 1];
    }
  }

  /* Wenn das Objekt einen z-Wert bekommt: */
  if (z > 0) {
    /* An der richtigen Stelle wieder einfgen.
     * Array wird eins lnger, Elemente dahinter rutschen eins nach hinten */
    if (MzBufCnt == MzBufSize) {
      cerr << "zBuf overflow!" << endl;
      exit(1);
    }
    /* richtige Stelle suchen */
    for (i = MzBufCnt; (i > 0) && (MzBuf[i - 1]->mZ > z); --i) {
      /* gehrt noch weiter vorne hin: Elemente eins nach hinten schieben */
      MzBuf[i] = MzBuf[i - 1];
    }
    MzBuf[i] = this;
    MzBufCnt++;
  }

  mZ = z;
}
  
void BigObj::move(int xOffset, int yOffset) {
  undraw();
  mX += xOffset;
  mY += yOffset;
  draw();
}
  
void BigObj::scale(int percentX, int percentY) {
  undraw();
  mW = (mW * percentX) / 100;
  mH = (mH * percentY) / 100;
  draw();
}
  
void BigObj::rotate() {
  int tmp;
  undraw();
  tmp = mW;
  mW = mH;
  mH = tmp;
  draw();
}

void BigObj::drawAll() {
  for (int i = 0; i < MzBufCnt; ++i) {
    MzBuf[i]->draw();
  }
}
