// C++ Vererbung: Geom. Objekte
// Klasse Rect
//
// Klaus Kusche, 2011

#ifndef _RECT_HXX
#define _RECT_HXX

#include "color.hxx"
#include "bigobj.hxx"

class Rect : public BigObj {
  public:
    Rect(const Color &color, int x, int y, int w, int h) :
      BigObj(color, x, y, w, h) {draw();}  // Basisklassen-Konstruktor aufrufen
    Rect(const Rect &orig) :
      BigObj(orig) {draw();}
    virtual ~Rect() {undraw();}

    virtual void draw();
    virtual void undraw();

    virtual Rect *clone() const {
      return new Rect(*this);
    }
    
  private:
    Rect &operator=(const Rect &val); // wegdefinieren (bleibt undef)!
};

#endif
